various fixes and improvements
[distro-setup] / distro-begin
1 #!/bin/bash -l
2 # Copyright (C) 2016 Ian Kelling
3 #
4 # Licensed under the Apache License, Version 2.0 (the "License");
5 # you may not use this file except in compliance with the License.
6 # You may obtain a copy of the License at
7 #
8 # http://www.apache.org/licenses/LICENSE-2.0
9 #
10 # Unless required by applicable law or agreed to in writing, software
11 # distributed under the License is distributed on an "AS IS" BASIS,
12 # WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
13 # See the License for the specific language governing permissions and
14 # limitations under the License.
15
16
17
18
19 # for bootstrapping a new machine
20
21 # in case we need it,
22 # to make ssh interactive shell run better, we run this first.
23 sudo bash -c 'source /a/c/.bashrc && source /a/exe/ssh-emacs-setup'
24
25
26 # usage: $0 [-r] HOSTNAME
27
28 # tips:
29 # run any sudo command first so your pass is cached
30 # set the scrollback to unlimited in case something goes wrong
31
32 if [[ $EUID == 0 ]]; then
33 if getent passwd iank || getent passwd ian ; then
34 echo "$0: error: running as root. unprivileged user exists. use it."
35 exit 1
36 else
37 echo "$0: warning: running as root. I will setup users then exit"
38 fi
39 fi
40
41 interactive=true # set this to false to force set -x
42 [[ $- == *i* ]] || interactive=false
43
44 if ! $interactive; then
45 set -x
46 set -e -o pipefail
47 fi
48 set -E
49 trap 'echo "$0:$LINENO:error: \"$BASH_COMMAND\" returned $?"' ERR
50
51 exec &> >(sudo tee -a /var/log/distro-begin)
52 echo "$0: $(date): starting now)"
53
54 # headless=false # unused atm
55 recompile=false
56 # for copying to a new data fs
57 bootstrapfs=false # old flag, needs new look before using.
58 while [[ $1 == -* ]]; do
59 case $1 in
60 -r) recompile=true; shift ;;
61 esac
62 done
63
64 if [[ $1 ]]; then
65 export HOSTNAME=$1
66 fi
67
68 for f in iank-dev htpc treetowl x2 frodo tp li lj demohost kw; do
69 eval "$f() { [[ $HOSTNAME == $f ]]; }"
70 done
71 has_p() { ! linode; } # when tp is tracis, then not tp either
72 has_x() { ! linode; }
73 linode() { lj || li; }
74 has_btrfs() { ! linode; }
75 home_network() { ! linode; }
76 encrypted() { has_p; }
77
78 shopt -s extglob
79 export GLOBIGNORE=*/.:*/..
80 umask 0002
81
82
83 ####### end command line parsing
84
85 PATH="/a/exe:$PATH"
86 sed="sed --follow-symlinks"
87
88 ##### begin setup encryption scripts ######
89 if encrypted; then
90 # I tried making a service which was dependent on reboot.target,
91 # but it happened too late in the shutdown process.
92 sudo dd of=/etc/systemd/system/keyscripton.service <<'EOF'
93 [Unit]
94 Description=Turn on automatic decryption of drives on boot
95 # tried using graphical.target, but it made my display manager restart before rebooting.
96 # generally, I don't think targets order shutdown like they do startup.
97 # So, I did systemd-analyze plot > something.svg, and picked a reliably started
98 # service that happens late in the game.
99 After=ntp.service
100 DefaultDependencies=no
101 # not sure if needed, makes sure we shut down before reboot.target
102 Conflicts=reboot.target
103
104 [Service]
105 Type=oneshot
106 RemainAfterExit=yes
107 ExecStart=/bin/true
108 ExecStop=/a/exe/keyscript-on
109
110 [Install]
111 WantedBy=keyscriptoff.service
112 EOF
113 sudo systemctl daemon-reload # needed if the file was already there
114 sudo systemctl stop keyscripton.service
115 # sudo systemctl start keyscripton.service
116 sudo systemctl enable keyscripton.service
117
118 sudo dd of=/etc/systemd/system/keyscriptoff.service <<'EOF'
119 [Unit]
120 Description=Turn off automatic decryption of drives on boot
121
122 [Service]
123 Type=oneshot
124 ExecStart=/a/exe/keyscript-off
125
126 [Install]
127 WantedBy=multi-user.target
128 EOF
129 sudo systemctl daemon-reload # needed if the file was already there
130 sudo systemctl enable keyscriptoff.service
131 sudo systemctl start keyscriptoff.service
132 fi
133 ##### end setup encryption scripts ######
134
135
136 install-myqueue
137
138 # this script has been designed to be idempotent
139 # todo, it would be nice to cut down on some of the output
140
141
142 for x in /a/bin/errhandle/*-function; do
143 source $x
144 done
145
146
147 set +e
148 $interactive || errcatch
149 set +x
150 source /a/bin/distro-functions/src/identify-distros
151 $interactive || set -x
152
153 if isfedora; then
154 # comment out line disallowing calling sudo in scripts
155 sudo $sed -i 's/^Defaults *requiretty/#\0 # ian commented/' /etc/sudoers
156 # turn on magic sysrq commands for this boot cycle
157 echo 1 > sudo dd of=/proc/sys/kernel/sysrq
158 echo "kernel.sysrq = 1" > /etc/sysctl.d/90-sysrq.conf
159 # selinux is not user friendly. Like, you enable samba, but you haven't run the magic selinux commands so it doesn't work
160 # and you have no idea why.
161 sudo $sed -i 's/^\(SELINUX=\).*/\1disabled/' /etc/selinux/config
162 selinuxenabled && sudo setenforce 0
163 fi
164
165
166 # already ran for pxe installs, but used for vps & updates
167 distro=$(distro-name)
168 case $distro in
169 ubuntu|debian|trisquel)
170 sudo bash -c ". /a/bin/fai/fai-wrapper && /a/bin/fai/fai/config/scripts/GRUB_PC/11-iank"
171 ;;
172 *)
173 sudo bash -c ". /a/bin/fai/fai-wrapper &&
174 /a/bin/fai/fai/config/distro-install-common/end"
175 ;;
176 esac
177
178 sudo $sed -i '/^127\.0\.1\.1/d' /etc/hosts
179 echo "127.0.1.1 $HOSTNAME.b8.nz $HOSTNAME" | sudo tee -a /etc/hosts
180
181
182 if [[ $EUID == 0 ]]; then
183 echo "$0: running as root. exiting now that users are setup"
184 exit 0
185 fi
186
187
188 #### begin link bashrc for root ######
189 for x in /a/c/{.bashrc,brc,.bash_profile,.profile,.inputrc,path_add_function}; do
190 sudo -i <<EOF
191 PATH="/a/exe:$PATH"
192 lnf $x /root
193 EOF
194 done
195 #### end link bashrc repo for root ######
196
197 # li needs the bind group before conflink
198 if [[ $HOSTNAME == li ]]; then
199 getent group bind &>/dev/null || sudo groupadd -r bind
200 fi
201 # this needs to be before installing pacserve so we have gpg conf.
202 conflink
203
204 set +x
205 errallow
206 source /etc/profile.d/environment.sh
207 source ~/.bashrc
208 $interactive || errcatch
209 $interactive || set -x
210
211
212 # passwordless sudo
213 tu /etc/sudoers <<EOF
214 $USER ALL=(ALL) NOPASSWD: ALL
215 Defaults env_keep += SUDOD
216 # makes ubuntu be like debian
217 # https://unix.stackexchange.com/a/91572
218 Defaults always_set_home
219 EOF
220
221
222 # enable magic sysrq keys. debian docs say it is already enabled by default
223 isfedora && tu /etc/sysctl.conf 'kernel.sysrq = 1'
224
225
226 if isdeb; then
227 codename=$(debian-codename)
228 ## ian: disabled. backports are not being published atm due to rust packaging issue
229 # if isdebian-stable && has_x; then
230 # s dd of=/etc/apt/sources.list.d/mozilla-iceweasel.list <<EOF
231 # deb http://mozilla.debian.net/ $codename-backports firefox-release
232 # deb-src http://mozilla.debian.net/ $codename-backports firefox-release
233 # EOF
234 # p update
235 # # take care of mozilla signing errors in previous command
236 # pi pkg-mozilla-archive-keyring
237 # fi
238 p update
239
240 fi
241
242 if isarch; then
243 #https://wiki.archlinux.org/index.php/Arch_User_Repository#Installing_packages
244 sudo pacman -S --noconfirm --needed base-devel jq
245 # pacaur seems to be the best, although it + cower has a few minor bugs,
246 # its design goals seem good, so, going for it.
247
248 aurpi() {
249 for p in "$@"; do
250 tempdir=$(mktemp -d)
251 pushd $tempdir
252 aurex "$p"
253 makepkg -sri --skippgpcheck --noconfirm
254 popd
255 rm -rf $tempdir
256 done
257 }
258 aurpi cower pacaur
259
260 pi pacserve
261
262 x=$(mktemp); /usr/bin/pacman.conf-insert_pacserve >$x
263 sudo dd of=/etc/pacman.conf if=$x; rm $x
264 sudo systemctl enable pacserve.service
265 sudo systemctl start pacserve.service
266
267 # strange error if just installing trash-cli: "pyalpm requires python",
268 # so I see that it requires python2, and installing that manually fixes it.
269 # I didn't see this on earlier installation, main thing which changed was
270 # pacserve, so not sure if it's related.
271 pi python2
272 fi
273
274 pup
275 pi trash-cli
276
277
278 ###### link files ###########
279 # convenient to just do all file linking in one place
280
281
282 s lnf -T /a/bin /b
283 s lnf -T /nocow/t /t
284
285 if has_p; then
286 lnf -T /p/News ~/News
287 fi
288
289 s lnf /q/root/.editor-backups /q/root/.undo-tree-history \
290 /a/opt /a/c/.emacs.d $HOME/mw_vars /k/backup /root
291
292 rootsshsync
293
294 s lnf /a/c/.vim /a/c/.vimrc /a/c/.gvimrc /root
295
296 # machine is going away
297 # if [[ $HOSTNAME == htpc ]]; then
298 # lnf -T /i/Videos ~/Downloads
299 # fi
300
301 if has_p; then
302 # for dovecot
303 lnf -T /i/k/mboxes ~/mail
304 fi
305
306
307 ##### basic needed packages
308
309 ### begin setup for keyboard and redshift ###
310 case $(distro-name) in
311
312 trisquel|ubuntu|debian)
313 if has_x; then
314 if isdebian-testing; then
315 pi xmacro/unstable # has no unstable deps
316 else
317 pi xmacro
318 fi
319 pi gtk-redshift xinput
320 fi
321 ;;&
322 fedora)
323 p -y groupinstall development-tools c-development books admin-tools
324 pi wget man-pages
325 if has_x; then
326 pi redshift-gtk
327 # debian has this package patched to work, upstream is dead
328 # tried using alien, pi alien, alien -r *.deb, rpm -Uhv *.rpm, got this error, so fuck it
329 # file /usr/bin from install of xmacro-0.3pre_20000911-7.x86_64 conflicts with file from package filesystem-3.2-19.fc20.x86_64
330 # http://packages.debian.org/source/sid/xmacro
331 pi patch libXtst-devel
332 cd $(mktemp -d)
333 wget http://ftp.de.debian.org/debian/pool/main/x/xmacro/xmacro_0.3pre-20000911.orig.tar.gz
334 wget http://ftp.de.debian.org/debian/pool/main/x/xmacro/xmacro_0.3pre-20000911-6.diff.gz
335 ex *.gz
336 patch -p0 < xmacro_0.3pre-20000911-6.diff
337 cd xmacro-0.3pre-20000911.orig
338 make
339 sleep 1 # not sure why the following command couldn\'t find, so trying this
340 # no make install target
341 s cp -f xmacroplay xmacrorec xmacrorec2 /usr/local/bin
342 fi
343 ;;&
344 arch)
345 # like apt-cache
346 pi pkgfile
347 s pkgfile --update
348 if has_x; then
349 # libxtst is missing dep https://aur.archlinux.org/packages/xmacro/#news
350 pi xorg-server redshift xorg-xinput libxtst xmacro
351
352 # background:
353 # https://aur.archlinux.org/packages/xkbset/#comment-545419
354 cert=$(mktemp)
355 cat >$cert <<'EOF'
356 -----BEGIN CERTIFICATE-----
357 MIIJADCCB+igAwIBAgIRAIVAhZ0TMbQ5jTm0koI8X6YwDQYJKoZIhvcNAQELBQAw
358 djELMAkGA1UEBhMCVVMxCzAJBgNVBAgTAk1JMRIwEAYDVQQHEwlBbm4gQXJib3Ix
359 EjAQBgNVBAoTCUludGVybmV0MjERMA8GA1UECxMISW5Db21tb24xHzAdBgNVBAMT
360 FkluQ29tbW9uIFJTQSBTZXJ2ZXIgQ0EwHhcNMTUxMjA4MDAwMDAwWhcNMTgxMjA3
361 MjM1OTU5WjCBsTELMAkGA1UEBhMCVVMxDjAMBgNVBBETBTY1MjExMREwDwYDVQQI
362 EwhNaXNzb3VyaTERMA8GA1UEBxMIQ29sdW1iaWExHzAdBgNVBAkTFjExMDAgQ2Fy
363 cmllIEZyYW5ja2UgRHIxHzAdBgNVBAoTFlVuaXZlcnNpdHkgb2YgTWlzc291cmkx
364 CzAJBgNVBAsTAk1VMR0wGwYDVQQDExRmYWN1bHR5Lm1pc3NvdXJpLmVkdTCCASIw
365 DQYJKoZIhvcNAQEBBQADggEPADCCAQoCggEBAN8Kap8hASpxQeqjHibGsCR1PBkh
366 nW9p5FkuhGpMW/3ko8QfxH0W1Hq2y2DTFUmq17kH3GfT3h9a7HcmUrC3q15PciOB
367 WR3j8u0bDfVppyAZXiHJzYGN7xHiPrZtFEGgwZd28+sW80WXTbGl+zKkmeZguGdH
368 AVGeWJEFK44ctLbpjHWCy+xNuhxJuL4olwPoV7WX9IUhceC0rxYQANhLGOJhbchj
369 Z76MA8dc2K3CZI5m7VqQwl09QSnCfz00afUr88ny9vj1S5k2ADS46gaE9O0lM6EY
370 z/uZvMizXN/4ko+hFBjCSt0Vhxjx0kYDSP15btiwh700ywBEubpvLROmd48CAwEA
371 AaOCBUswggVHMB8GA1UdIwQYMBaAFB4Fo3ePbJbiW4dLprSGrHEADOc4MB0GA1Ud
372 DgQWBBTTNWrSb+V/Ayy0i8W2LExMUisQMzAOBgNVHQ8BAf8EBAMCBaAwDAYDVR0T
373 AQH/BAIwADAdBgNVHSUEFjAUBggrBgEFBQcDAQYIKwYBBQUHAwIwZwYDVR0gBGAw
374 XjBSBgwrBgEEAa4jAQQDAQEwQjBABggrBgEFBQcCARY0aHR0cHM6Ly93d3cuaW5j
375 b21tb24ub3JnL2NlcnQvcmVwb3NpdG9yeS9jcHNfc3NsLnBkZjAIBgZngQwBAgIw
376 RAYDVR0fBD0wOzA5oDegNYYzaHR0cDovL2NybC5pbmNvbW1vbi1yc2Eub3JnL0lu
377 Q29tbW9uUlNBU2VydmVyQ0EuY3JsMHUGCCsGAQUFBwEBBGkwZzA+BggrBgEFBQcw
378 AoYyaHR0cDovL2NydC51c2VydHJ1c3QuY29tL0luQ29tbW9uUlNBU2VydmVyQ0Ff
379 Mi5jcnQwJQYIKwYBBQUHMAGGGWh0dHA6Ly9vY3NwLnVzZXJ0cnVzdC5jb20wggOg
380 BgNVHREEggOXMIIDk4IUZmFjdWx0eS5taXNzb3VyaS5lZHWCGmFkdmlzaW5nLmNv
381 YXMubWlzc291cmkuZWR1ghBhaGEubWlzc291cmkuZWR1ghZhbGwtY3JhZnQubWlz
382 c291cmkuZWR1gh1hbWVyaWNhbmJhc2tldHJ5Lm1pc3NvdXJpLmVkdYIXYW5kcmVh
383 cmlldy5taXNzb3VyaS5lZHWCFWFydGdyYWRzLm1pc3NvdXJpLmVkdYIYYmFja3Vw
384 LmNvYXMubWlzc291cmkuZWR1ghBiaWMubWlzc291cmkuZWR1ghZibG9nLmNvYXMu
385 bWlzc291cmkuZWR1ghVjb3dhbmxhYi5taXNzb3VyaS5lZHWCFWRhZS5zdGF0Lm1p
386 c3NvdXJpLmVkdYIRZGljZS5taXNzb3VyaS5lZHWCIGRpZ2l0YWxzdG9yeXRlbGxp
387 bmcubWlzc291cmkuZWR1gg9lYS5taXNzb3VyaS5lZHWCG2Vib29rLWRldi5tYXRo
388 Lm1pc3NvdXJpLmVkdYIXZWJvb2suZWNvbi5taXNzb3VyaS5lZHWCGGVuZ2xpc2g4
389 MDA2Lm1pc3NvdXJpLmVkdYIZZXVnZW5lZml0c2NoLm1pc3NvdXJpLmVkdYIYZXVy
390 b2t1bHR1cmUubWlzc291cmkuZWR1ghNmY2RsYWIubWlzc291cmkuZWR1ghZnZW9t
391 dXNldW0ubWlzc291cmkuZWR1ghRoYXJzdGFkLm1pc3NvdXJpLmVkdYITbHVkd2ln
392 Lm1pc3NvdXJpLmVkdYIYbWFjaGluZXNob3AubWlzc291cmkuZWR1ghNtYWpvcnMu
393 bWlzc291cmkuZWR1ghBtZ2EubWlzc291cmkuZWR1ghdvcmdhbnByaW50Lm1pc3Nv
394 dXJpLmVkdYIUcGh5c2ljcy5taXNzb3VyaS5lZHWCFHBtLmNoZW0ubWlzc291cmku
395 ZWR1ghxyZWNydWl0aW5nLmVjb24ubWlzc291cmkuZWR1ghdyZXBlYy5lY29uLm1p
396 c3NvdXJpLmVkdYIUc2NhbmxhYi5taXNzb3VyaS5lZHWCFnNzc2MuY29hcy5taXNz
397 b3VyaS5lZHWCF3RlYWNoLmNvYXMubWlzc291cmkuZWR1ghd0b3B0ZWFjaGVyLm1p
398 c3NvdXJpLmVkdYIQdnNmLm1pc3NvdXJpLmVkdYIid2hpdGVwYXBlci5ncmFkc2No
399 b29sLm1pc3NvdXJpLmVkdTANBgkqhkiG9w0BAQsFAAOCAQEAQutYVAqG7MpmG2Nu
400 Z/UypjYkN4JvwRbKBpTrce2IT/Sy29x6chBbyD+0WE6QORBtaUHuzE1KoXqpnF4M
401 QrkKw0oBAC6x9dISoomq0DkIndtoBYYLaxSoII6F4OGWgF7pQ/7MiCBYzsKQpn9t
402 aofMcTfvnCjq+MCIaeYnUKBVww0lOJlUxZGKxFJvRpf78HfbBauojjRO2zXLZD/u
403 KMspbTfDaj5etIgWGShY2eml3N/SjAENmZYkcgDBYFyi8CckcEBAVzpH1+D+7Anz
404 txHSYDNHAYLv83MwbegApa1FwPqlG/4SdEU8G6e6Xf5GLC/6GPGVTUpr7o348OOO
405 lzGQzw==
406 -----END CERTIFICATE-----
407 -----BEGIN CERTIFICATE-----
408 MIIF+TCCA+GgAwIBAgIQRyDQ+oVGGn4XoWQCkYRjdDANBgkqhkiG9w0BAQwFADCB
409 iDELMAkGA1UEBhMCVVMxEzARBgNVBAgTCk5ldyBKZXJzZXkxFDASBgNVBAcTC0pl
410 cnNleSBDaXR5MR4wHAYDVQQKExVUaGUgVVNFUlRSVVNUIE5ldHdvcmsxLjAsBgNV
411 BAMTJVVTRVJUcnVzdCBSU0EgQ2VydGlmaWNhdGlvbiBBdXRob3JpdHkwHhcNMTQx
412 MDA2MDAwMDAwWhcNMjQxMDA1MjM1OTU5WjB2MQswCQYDVQQGEwJVUzELMAkGA1UE
413 CBMCTUkxEjAQBgNVBAcTCUFubiBBcmJvcjESMBAGA1UEChMJSW50ZXJuZXQyMREw
414 DwYDVQQLEwhJbkNvbW1vbjEfMB0GA1UEAxMWSW5Db21tb24gUlNBIFNlcnZlciBD
415 QTCCASIwDQYJKoZIhvcNAQEBBQADggEPADCCAQoCggEBAJwb8bsvf2MYFVFRVA+e
416 xU5NEFj6MJsXKZDmMwysE1N8VJG06thum4ltuzM+j9INpun5uukNDBqeso7JcC7v
417 HgV9lestjaKpTbOc5/MZNrun8XzmCB5hJ0R6lvSoNNviQsil2zfVtefkQnI/tBPP
418 iwckRR6MkYNGuQmm/BijBgLsNI0yZpUn6uGX6Ns1oytW61fo8BBZ321wDGZq0GTl
419 qKOYMa0dYtX6kuOaQ80tNfvZnjNbRX3EhigsZhLI2w8ZMA0/6fDqSl5AB8f2IHpT
420 eIFken5FahZv9JNYyWL7KSd9oX8hzudPR9aKVuDjZvjs3YncJowZaDuNi+L7RyML
421 fzcCAwEAAaOCAW4wggFqMB8GA1UdIwQYMBaAFFN5v1qqK0rPVIDh2JvAnfKyA2bL
422 MB0GA1UdDgQWBBQeBaN3j2yW4luHS6a0hqxxAAznODAOBgNVHQ8BAf8EBAMCAYYw
423 EgYDVR0TAQH/BAgwBgEB/wIBADAdBgNVHSUEFjAUBggrBgEFBQcDAQYIKwYBBQUH
424 AwIwGwYDVR0gBBQwEjAGBgRVHSAAMAgGBmeBDAECAjBQBgNVHR8ESTBHMEWgQ6BB
425 hj9odHRwOi8vY3JsLnVzZXJ0cnVzdC5jb20vVVNFUlRydXN0UlNBQ2VydGlmaWNh
426 dGlvbkF1dGhvcml0eS5jcmwwdgYIKwYBBQUHAQEEajBoMD8GCCsGAQUFBzAChjNo
427 dHRwOi8vY3J0LnVzZXJ0cnVzdC5jb20vVVNFUlRydXN0UlNBQWRkVHJ1c3RDQS5j
428 cnQwJQYIKwYBBQUHMAGGGWh0dHA6Ly9vY3NwLnVzZXJ0cnVzdC5jb20wDQYJKoZI
429 hvcNAQEMBQADggIBAC0RBjjW29dYaK+qOGcXjeIT16MUJNkGE+vrkS/fT2ctyNMU
430 11ZlUp5uH5gIjppIG8GLWZqjV5vbhvhZQPwZsHURKsISNrqOcooGTie3jVgU0W+0
431 +Wj8mN2knCVANt69F2YrA394gbGAdJ5fOrQmL2pIhDY0jqco74fzYefbZ/VS29fR
432 5jBxu4uj1P+5ZImem4Gbj1e4ZEzVBhmO55GFfBjRidj26h1oFBHZ7heDH1Bjzw72
433 hipu47Gkyfr2NEx3KoCGMLCj3Btx7ASn5Ji8FoU+hCazwOU1VX55mKPU1I2250Lo
434 RCASN18JyfsD5PVldJbtyrmz9gn/TKbRXTr80U2q5JhyvjhLf4lOJo/UzL5WCXED
435 Smyj4jWG3R7Z8TED9xNNCxGBMXnMete+3PvzdhssvbORDwBZByogQ9xL2LUZFI/i
436 eoQp0UM/L8zfP527vWjEzuDN5xwxMnhi+vCToh7J159o5ah29mP+aJnvujbXEnGa
437 nrNxHzu+AGOePV8hwrGGG7hOIcPDQwkuYwzN/xT29iLp/cqf9ZhEtkGcQcIImH3b
438 oJ8ifsCnSbu0GB9L06Yqh7lcyvKDTEADslIaeSEINxhO2Y1fmcYFX/Fqrrp1WnhH
439 OjplXuXE0OPa0utaKC25Aplgom88L2Z8mEWcyfoB7zKOfD759AN7JKZWCYwk
440 -----END CERTIFICATE-----
441 -----BEGIN CERTIFICATE-----
442 MIIF3jCCA8agAwIBAgIQAf1tMPyjylGoG7xkDjUDLTANBgkqhkiG9w0BAQwFADCB
443 iDELMAkGA1UEBhMCVVMxEzARBgNVBAgTCk5ldyBKZXJzZXkxFDASBgNVBAcTC0pl
444 cnNleSBDaXR5MR4wHAYDVQQKExVUaGUgVVNFUlRSVVNUIE5ldHdvcmsxLjAsBgNV
445 BAMTJVVTRVJUcnVzdCBSU0EgQ2VydGlmaWNhdGlvbiBBdXRob3JpdHkwHhcNMTAw
446 MjAxMDAwMDAwWhcNMzgwMTE4MjM1OTU5WjCBiDELMAkGA1UEBhMCVVMxEzARBgNV
447 BAgTCk5ldyBKZXJzZXkxFDASBgNVBAcTC0plcnNleSBDaXR5MR4wHAYDVQQKExVU
448 aGUgVVNFUlRSVVNUIE5ldHdvcmsxLjAsBgNVBAMTJVVTRVJUcnVzdCBSU0EgQ2Vy
449 dGlmaWNhdGlvbiBBdXRob3JpdHkwggIiMA0GCSqGSIb3DQEBAQUAA4ICDwAwggIK
450 AoICAQCAEmUXNg7D2wiz0KxXDXbtzSfTTK1Qg2HiqiBNCS1kCdzOiZ/MPans9s/B
451 3PHTsdZ7NygRK0faOca8Ohm0X6a9fZ2jY0K2dvKpOyuR+OJv0OwWIJAJPuLodMkY
452 tJHUYmTbf6MG8YgYapAiPLz+E/CHFHv25B+O1ORRxhFnRghRy4YUVD+8M/5+bJz/
453 Fp0YvVGONaanZshyZ9shZrHUm3gDwFA66Mzw3LyeTP6vBZY1H1dat//O+T23LLb2
454 VN3I5xI6Ta5MirdcmrS3ID3KfyI0rn47aGYBROcBTkZTmzNg95S+UzeQc0PzMsNT
455 79uq/nROacdrjGCT3sTHDN/hMq7MkztReJVni+49Vv4M0GkPGw/zJSZrM233bkf6
456 c0Plfg6lZrEpfDKEY1WJxA3Bk1QwGROs0303p+tdOmw1XNtB1xLaqUkL39iAigmT
457 Yo61Zs8liM2EuLE/pDkP2QKe6xJMlXzzawWpXhaDzLhn4ugTncxbgtNMs+1b/97l
458 c6wjOy0AvzVVdAlJ2ElYGn+SNuZRkg7zJn0cTRe8yexDJtC/QV9AqURE9JnnV4ee
459 UB9XVKg+/XRjL7FQZQnmWEIuQxpMtPAlR1n6BB6T1CZGSlCBst6+eLf8ZxXhyVeE
460 Hg9j1uliutZfVS7qXMYoCAQlObgOK6nyTJccBz8NUvXt7y+CDwIDAQABo0IwQDAd
461 BgNVHQ4EFgQUU3m/WqorSs9UgOHYm8Cd8rIDZsswDgYDVR0PAQH/BAQDAgEGMA8G
462 A1UdEwEB/wQFMAMBAf8wDQYJKoZIhvcNAQEMBQADggIBAFzUfA3P9wF9QZllDHPF
463 Up/L+M+ZBn8b2kMVn54CVVeWFPFSPCeHlCjtHzoBN6J2/FNQwISbxmtOuowhT6KO
464 VWKR82kV2LyI48SqC/3vqOlLVSoGIG1VeCkZ7l8wXEskEVX/JJpuXior7gtNn3/3
465 ATiUFJVDBwn7YKnuHKsSjKCaXqeYalltiz8I+8jRRa8YFWSQEg9zKC7F4iRO/Fjs
466 8PRF/iKz6y+O0tlFYQXBl2+odnKPi4w2r78NBc5xjeambx9spnFixdjQg3IM8WcR
467 iQycE0xyNN+81XHfqnHd4blsjDwSXWXavVcStkNr/+XeTWYRUc+ZruwXtuhxkYze
468 Sf7dNXGiFSeUHM9h4ya7b6NnJSFd5t0dCy5oGzuCr+yDZ4XUmFF0sbmZgIn/f3gZ
469 XHlKYC6SQK5MNyosycdiyA5d9zZbyuAlJQG03RoHnHcAP9Dc1ew91Pq7P8yF1m9/
470 qS3fuQL39ZeatTXaw2ewh0qpKJ4jjv9cJ2vhsE/zB+4ALtRZh8tSQZXq9EfX7mRB
471 VXyNWQKV3WKdwrnuWih0hKWbt5DHDAff9Yk2dDLWKMGwsAvgnEzDHNb842m1R0aB
472 L6KCq9NjRHDEjf8tM7qtj3u1cIiuPhnPQCjY/MiQu12ZIvVS5ljFH4gxQ+6IHdfG
473 jjxDah2nGN59PRbxYvnKkKj9
474 -----END CERTIFICATE-----
475 EOF
476 cat /etc/ssl/certs/ca-certificates.crt >> $cert
477 CURL_CA_BUNDLE=$cert pi xkbset
478 fi
479
480 ;;&
481 ubuntu|trisquel|debian|fedora)
482 if has_x; then
483 if isdebian-testing; then
484 # xkbset was in testing for quite a while, dunno
485 # why it\'s not anymore. Sometime I should check and
486 # see if it\'s back in testing, but the unstable package
487 # doesn\'t upgrade anything form testing, and it\'s tiny
488 # so I\'m not bothering to automate it.
489 pi xkbset/unstable
490 else
491 pi xkbset
492 fi
493 fi
494 ;;&
495 esac
496 if has_x; then
497 pi xbindkeys
498 fi
499 ### end setup for keyboard and redshift ###
500
501
502 pi cryptsetup lvm2
503 # enables trim for volume delete, other rare commands.
504 sudo $sed -ri 's/( *issue_discards\b).*/\1 = 1/' /etc/lvm/lvm.conf
505
506 if encrypted; then
507 if isdeb; then
508 sudo cp /usr/share/doc/util-linux/examples/fstrim.{service,timer} /etc/systemd/system
509 fi
510 # does weekly trim
511 sudo systemctl enable fstrim.timer
512 fi
513
514 dirs=(/mnt/{1,2,3,4,5,6,7,8,9})
515 s mkdir -p "${dirs[@]}"
516 s chown $USER:$USER "${dirs[@]}"
517
518
519 tu /etc/fstab <<'EOF'
520 /i/w /w none bind,noauto 0 0
521 /i/k /k none bind,noauto 0 0
522 EOF
523
524
525 if ! mountpoint /kr; then
526 s mkdir -p /kr
527 s chown $USER:traci /kr
528 fi
529
530 if home_network; then
531 if [[ $HOSTNAME == frodo ]]; then
532 tu /etc/fstab <<'EOF'
533 /k /kr none bind,noauto 0 0
534 EOF
535 else
536 tu /etc/fstab <<'EOF'
537 frodo:/k /kr nfs noauto 0 0
538 EOF
539 fi
540 fi
541
542 s mkdir -p /q /i/{w,k}
543 for dir in /{i,w,k}; do
544 if mountpoint $dir; then continue; fi # already mounted
545 s mkdir -p $dir
546 s chown $USER:$USER $dir
547 done
548
549 # not needed for all hosts, but rather just keep it uniform
550 s mkdir -p /mnt/iroot
551
552 # debian auto mounting of multi-disk encrypted btrfs is busted. It is
553 # in jessie, and in stretch as of 11/26/2016 I have 4 disks in cryptab,
554 # based on 3 of those, it creates .device units for /dev/mapper/dev...
555 # then waits endlessly for them on bootup, after the /dev/mapper disks
556 # have already been created and exist. todo: create a simple repro
557 # for this in a vm and report it upstream.
558 if has_btrfs || home_network; then
559 pi nfs-common
560 s dd of=/root/imount <<'EOF'
561 #!/bin/bash
562 [[ $EUID == 0 ]] || exec sudo -E "$BASH_SOURCE" "$@"
563 set -eE -o pipefail
564 trap 'echo "$0:$LINENO:error: \"$BASH_COMMAND\" returned $?" >&2' ERR
565 for dir in /i /mnt/iroot /k /kr /w; do
566 if ! mountpoint $dir &>/dev/null && \
567 awk '{print $2}' /etc/fstab | grep -xF $dir &>/dev/null; then
568 if awk '{print $3}' /etc/fstab | grep -xF nfs &>/dev/null; then
569 mount $dir || echo "warning: failed to mount nfs on $dir"
570 else
571 mount $dir
572 fi
573 fi
574 done
575 EOF
576 s chmod +x /root/imount
577
578 s dd of=/etc/systemd/system/imount.service <<EOF
579 [Unit]
580 Description=Mount /i and related mountpoints
581 Before=syncthing@$USER.service
582
583 [Service]
584 Type=oneshot
585 ExecStart=/root/imount
586
587 [Install]
588 RequiredBy=syncthing@$USER.service
589 # note /kr needs networking, this target is the simplest way to
590 # time it when the network should be up, but not do something
591 # dumb like delay startup until the network is up. It happens
592 # at some time after network.target
593 WantedBy=multi-user.target
594 EOF
595 sudo systemctl daemon-reload # needed if the file was already there
596 sudo systemctl enable imount.service
597 sudo systemctl start imount.service
598 fi
599
600 dir=/nocow
601 if has_btrfs; then
602 if ! mountpoint $dir; then
603 subvol=/mnt/root/nocow
604 if [[ ! -e $subvol ]]; then
605 s btrfs subvolume create $subvol
606 s chown root:1000 $subvol
607 s chattr +C $subvol
608 fi
609
610 first_root_crypt=$(awk '$2 == "/" {print $1}' /etc/mtab)
611 tu /etc/fstab <<EOF
612 $first_root_crypt /nocow btrfs noatime,subvol=nocow 0 0
613 EOF
614 s mkdir -p $dir
615 s chown $USER:$USER $dir
616 s mount $dir
617 fi
618 else
619 sudo mkdir -p $dir
620 fi
621
622 # ssh and probably some other things care about parent directory
623 # ownership, and ssh doesn\'t allow any group writable parent
624 # directories, so we are forced to use a directory structure similar
625 # to home directories
626 s chown root:$USER /q
627 s chmod 755 /q
628
629
630 # it comes with stretch and arch, but not jessie.
631 # propogate /etc/udev/hwdb.d
632 if which systemd-hwdb; then
633 s systemd-hwdb update
634 ser restart systemd-udev-trigger
635 fi
636
637
638 if isdeb; then
639 # I\'ve had problems with postfix on debian:
640 # on stretch, a startup ordering issue caused all mail to fail.
641 # postfix changed defaults to only use ipv6 dns, causing all my mail to fail.
642 # exim4 is default on debian, so I assume it would
643 # be packaged better to avoid these types of things.
644 # I haven\'t gotten around to getting a non-debian exim
645 # setup.
646 mail-setup exim4
647 else
648 mail-setup postfix
649 fi
650
651 if isubuntu; then
652 # disable crash report annoying dialogs.
653 s dd of=/etc/default/apport <<<'enabled=0'
654 fi
655
656 # fai sets this an old way that doesn't work for stretch.
657 # no harm in setting it universally here.
658 # using debconf-set-selection, the area gets reset to ETC
659 # on my linode test machine after doing a dpkg-reconfigure, or a reinstall,
660 # so we are using expect :(
661 # I got a random error when running this, so I added a sleep
662 # rather than trying to write a whole detect and wait loop.
663 # E: Could not get lock /var/lib/dpkg/lock - open (11: Resource temporarily unavailable)
664 # E: Unable to lock the administration directory (/var/lib/dpkg/), is another process using it?
665 sleep 1
666 # todo: this is not idempotent, it fails when running twice, due to prepopulated values.
667 # check into unsetting them using debconf-set-selection.
668 s apt-get -y install --no-install-recommends expect
669 s expect <<EOF ||:
670 set force_conservative 0
671 spawn dpkg-reconfigure tzdata -freadline
672 expect -nocase timeout {exit 1} "Geographic area:"
673 send "\02512\r"
674 expect -nocase timeout {exit 1} "Time zone:"
675 send "\0255\r"
676 expect eof
677 exit
678 EOF
679
680
681 if has_x; then
682 if isarch; then
683 # install so it's build dependencies don't get removed.
684
685 # emacs git build is currently broken
686 if false; then
687 x=$(mktemp -d)
688 pushd $x
689 aurex emacs-git
690 makepkg -si --noconfirm
691 popd
692 rm -rf $x
693 else
694 pi emacs
695 fi
696 pi hunspell hunspell-en
697 else
698 if $recompile; then
699 /a/bin/buildscripts/emacs
700 else
701 /a/bin/buildscripts/emacs --no-r || /a/bin/buildscripts/emacs
702 fi
703 fi
704
705 # todo, figure this out for arch if we ever try out gnome.
706 if ! isarch; then
707 # install for multiple display managers in case we use one
708 if isdeb; then
709 dir=/etc/gdm3
710 elif isfedora; then
711 # fedora didn\'t have the 3.
712 dir=/etc/gdm
713 fi
714 s mkdir -p $dir/PostLogin
715 s command cp /a/bin/distro-setup/desktop-20-autostart.sh $dir/PostLogin/Default
716 s mkdir /etc/lightdm/lightdm.conf.d
717 s dd of=/etc/lightdm/lightdm.conf.d/12-iank.conf <<'EOF'
718 [SeatDefaults]
719 session-setup-script=/a/bin/distro-setup/desktop-20-autostart.sh
720 EOF
721 fi
722
723
724 pi ghc sakura
725 # todo, also note for work comp, scp opt/org-mode bin/build-scripts
726
727 # use the package manger version to install the cabal version
728 pi cabal-install
729 cabal update
730 PATH="$PATH:$HOME/.cabal/bin"
731
732 # todo, on older ubuntu I used cabal xmonad + xfce,
733 # see /a/bin/old-unused/xmonad-cabal.sh
734
735 # trying out the distros versions newer distros
736 pi xmonad
737 if isarch; then
738 # for displaying error messages.
739 # optional dependency in arch, standard elsewhere.
740 pi xorg-xmessage xmonad-contrib xorg-xsetroot xorg-xinit
741
742 # https://wiki.archlinux.org/index.php/Xinitrc
743 for homedir in /home/*; do
744 cp /etc/X11/xinit/xinitrc $homedir/.xinitrc
745 $sed -ri '/^ *twm\b/,$d' $homedir/.xinitrc
746 tee -a $homedir/.xinitrc <<'EOF'
747 /a/bin/desktop-20-autostart.sh
748 xsetroot -cursor_name left_ptr
749 exec xmonad
750 EOF
751 done
752 else
753 pi suckless-tools
754 fi
755 pi dmenu
756
757 if tp || x2; then
758 case $distro in
759 debian)
760 pi task-laptop
761 ;;
762 ubuntu|trisquel)
763 # the exact packages that task-laptop would install, since ubuntu
764 # doesn\'t have this virtual in practice package.
765 pi avahi-autoipd bluetooth powertop iw wireless-tools wpasupplicant
766 ;;
767 # todo: other distros unknown
768 esac
769 fi
770 fi
771
772 # the first pup command can kill off our /etc/ mod, so rerun this
773 /a/exe/ssh-emacs-setup
774 echo "$0: $(date): ending now"
775 exit 0